std::atomic< _Tp * > Struct Template Reference
Atomics

`#include <atomic>`

## Public Types

typedef __atomic_base< _Tp * > | __base_type
typedef _Tp * | __pointer_type
using | difference_type
using | value_type

## Public Member Functions

constexpr | atomic (__pointer_type __p) noexcept
| atomic (const atomic &)=delete
bool | compare_exchange_strong (__pointer_type &__p1, __pointer_type __p2, memory_order __m1, memory_order __m2) noexcept
bool | compare_exchange_strong (__pointer_type &__p1, __pointer_type __p2, memory_order __m1, memory_order __m2) volatile noexcept
bool | compare_exchange_strong (__pointer_type &__p1, __pointer_type __p2, memory_order __m=memory_order_seq_cst) noexcept
bool | compare_exchange_strong (__pointer_type &__p1, __pointer_type __p2, memory_order __m=memory_order_seq_cst) volatile noexcept
bool | compare_exchange_weak (__pointer_type &__p1, __pointer_type __p2, memory_order __m1, memory_order __m2) noexcept
bool | compare_exchange_weak (__pointer_type &__p1, __pointer_type __p2, memory_order __m1, memory_order __m2) volatile noexcept
bool | compare_exchange_weak (__pointer_type &__p1, __pointer_type __p2, memory_order __m=memory_order_seq_cst) noexcept
bool | compare_exchange_weak (__pointer_type &__p1, __pointer_type __p2, memory_order __m=memory_order_seq_cst) volatile noexcept
__pointer_type | exchange (__pointer_type __p, memory_order __m=memory_order_seq_cst) noexcept
__pointer_type | exchange (__pointer_type __p, memory_order __m=memory_order_seq_cst) volatile noexcept
__pointer_type | fetch_add (ptrdiff_t __d, memory_order __m=memory_order_seq_cst) noexcept
__pointer_type | fetch_add (ptrdiff_t __d, memory_order __m=memory_order_seq_cst) volatile noexcept
__pointer_type | fetch_sub (ptrdiff_t __d, memory_order __m=memory_order_seq_cst) noexcept
__pointer_type | fetch_sub (ptrdiff_t __d, memory_order __m=memory_order_seq_cst) volatile noexcept
bool | is_lock_free () const noexcept
bool | is_lock_free () const volatile noexcept
__pointer_type | load (memory_order __m=memory_order_seq_cst) const noexcept
__pointer_type | load (memory_order __m=memory_order_seq_cst) const volatile noexcept
| operator __pointer_type () const noexcept
| operator __pointer_type () const volatile noexcept
| operator _Tp () const noexcept
__pointer_type | operator++ () noexcept
__pointer_type | operator++ () volatile noexcept
__pointer_type | operator++ (int) noexcept
__pointer_type | operator++ (int) volatile noexcept
__pointer_type | operator+= (ptrdiff_t __d) noexcept
__pointer_type | operator+= (ptrdiff_t __d) volatile noexcept
__pointer_type | operator-- () noexcept
__pointer_type | operator-- () volatile noexcept
__pointer_type | operator-- (int) noexcept
__pointer_type | operator-- (int) volatile noexcept
__pointer_type | operator-= (ptrdiff_t __d) noexcept
__pointer_type | operator-= (ptrdiff_t __d) volatile noexcept
__pointer_type | operator= (__pointer_type __p) noexcept
__pointer_type | operator= (__pointer_type __p) volatile noexcept
atomic & | operator= (const atomic &) volatile =delete
atomic & | operator= (const atomic &)=delete
void | store (__pointer_type __p, memory_order __m=memory_order_seq_cst) noexcept
void | store (__pointer_type __p, memory_order __m=memory_order_seq_cst) volatile noexcept

## Public Attributes

__base_type | _M_b

## Static Public Attributes

static constexpr bool | is_always_lock_free

## Detailed Description

template<typename _Tp>
struct std::atomic< _Tp * >

Partial specialization for pointer types.

Definition at line 415 of file atomic.

## Member Typedef Documentation

## __base_type

template<typename _Tp>

typedef __atomic_base<_Tp*> std::atomic< _Tp * >::__base_type

Definition at line 421 of file atomic.

## __pointer_type

template<typename _Tp>

typedef _Tp* std::atomic< _Tp * >::__pointer_type

Definition at line 420 of file atomic.

## difference_type

template<typename _Tp>

using std::atomic< _Tp * >::difference_type

Definition at line 418 of file atomic.

## value_type

template<typename _Tp>

using std::atomic< _Tp * >::value_type

Definition at line 417 of file atomic.

## Constructor & Destructor Documentation

## atomic()

template<typename _Tp>

std::atomic< _Tp * >::atomic | ( | __pointer_type | __p | ) |

inline constexpr noexcept

Definition at line 430 of file atomic.

## Member Function Documentation

## compare_exchange_strong() [1/4]

template<typename _Tp>

bool std::atomic< _Tp * >::compare_exchange_strong | ( | __pointer_type & | __p1,
|  | __pointer_type | __p2,
|  | memory_order | __m1,
|  | memory_order | __m2 )

inline noexcept

Definition at line 622 of file atomic.

## compare_exchange_strong() [2/4]

template<typename _Tp>

bool std::atomic< _Tp * >::compare_exchange_strong | ( | __pointer_type & | __p1,
|  | __pointer_type | __p2,
|  | memory_order | __m1,
|  | memory_order | __m2 ) volatile

inline noexcept

Definition at line 627 of file atomic.

## compare_exchange_strong() [3/4]

template<typename _Tp>

bool std::atomic< _Tp * >::compare_exchange_strong | ( | __pointer_type & | __p1,
|  | __pointer_type | __p2,
|  | memory_order | __m = memory_order_seq_cst )

inline noexcept

Definition at line 633 of file atomic.

## compare_exchange_strong() [4/4]

template<typename _Tp>

bool std::atomic< _Tp * >::compare_exchange_strong | ( | __pointer_type & | __p1,
|  | __pointer_type | __p2,
|  | memory_order | __m = memory_order_seq_cst ) volatile

inline noexcept

Definition at line 641 of file atomic.

## compare_exchange_weak() [1/4]

template<typename _Tp>

bool std::atomic< _Tp * >::compare_exchange_weak | ( | __pointer_type & | __p1,
|  | __pointer_type | __p2,
|  | memory_order | __m1,
|  | memory_order | __m2 )

inline noexcept

Definition at line 595 of file atomic.

## compare_exchange_weak() [2/4]

template<typename _Tp>

bool std::atomic< _Tp * >::compare_exchange_weak | ( | __pointer_type & | __p1,
|  | __pointer_type | __p2,
|  | memory_order | __m1,
|  | memory_order | __m2 ) volatile

inline noexcept

Definition at line 600 of file atomic.

## compare_exchange_weak() [3/4]

template<typename _Tp>

bool std::atomic< _Tp * >::compare_exchange_weak | ( | __pointer_type & | __p1,
|  | __pointer_type | __p2,
|  | memory_order | __m = memory_order_seq_cst )

inline noexcept

Definition at line 606 of file atomic.

## compare_exchange_weak() [4/4]

template<typename _Tp>

bool std::atomic< _Tp * >::compare_exchange_weak | ( | __pointer_type & | __p1,
|  | __pointer_type | __p2,
|  | memory_order | __m = memory_order_seq_cst ) volatile

inline noexcept

Definition at line 614 of file atomic.

## exchange() [1/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::exchange | ( | __pointer_type | __p,
|  | memory_order | __m = memory_order_seq_cst )

inline noexcept

Definition at line 585 of file atomic.

## exchange() [2/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::exchange | ( | __pointer_type | __p,
|  | memory_order | __m = memory_order_seq_cst ) volatile

inline noexcept

Definition at line 590 of file atomic.

## fetch_add() [1/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::fetch_add | ( | ptrdiff_t | __d,
|  | memory_order | __m = memory_order_seq_cst )

inline noexcept

Definition at line 664 of file atomic.

## fetch_add() [2/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::fetch_add | ( | ptrdiff_t | __d,
|  | memory_order | __m = memory_order_seq_cst ) volatile

inline noexcept

Definition at line 674 of file atomic.

## fetch_sub() [1/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::fetch_sub | ( | ptrdiff_t | __d,
|  | memory_order | __m = memory_order_seq_cst )

inline noexcept

Definition at line 684 of file atomic.

## fetch_sub() [2/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::fetch_sub | ( | ptrdiff_t | __d,
|  | memory_order | __m = memory_order_seq_cst ) volatile

inline noexcept

Definition at line 694 of file atomic.

## is_lock_free() [1/2]

template<typename _Tp>

bool std::atomic< _Tp * >::is_lock_free | ( |  | ) | const

inline noexcept

Definition at line 555 of file atomic.

## is_lock_free() [2/2]

template<typename _Tp>

bool std::atomic< _Tp * >::is_lock_free | ( |  | ) | const volatile

inline noexcept

Definition at line 559 of file atomic.

## load() [1/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::load | ( | memory_order | __m = memory_order_seq_cst | ) | const

inline noexcept

Definition at line 577 of file atomic.

## load() [2/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::load | ( | memory_order | __m = memory_order_seq_cst | ) | const volatile

inline noexcept

Definition at line 581 of file atomic.

## operator __pointer_type() [1/2]

template<typename _Tp>

std::atomic< _Tp * >::operator __pointer_type | ( |  | ) | const

inline noexcept

Definition at line 432 of file atomic.

## operator __pointer_type() [2/2]

template<typename _Tp>

std::atomic< _Tp * >::operator __pointer_type | ( |  | ) | const volatile

inline noexcept

Definition at line 435 of file atomic.

## operator _Tp()

std::atomic< _Tp >::operator _Tp | ( |  | ) | const

inline noexcept

Definition at line 233 of file atomic.

## operator++() [1/4]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator++ | ( |  | ) |

inline noexcept

Definition at line 483 of file atomic.

## operator++() [2/4]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator++ | ( |  | ) | volatile

inline noexcept

Definition at line 492 of file atomic.

## operator++() [3/4]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator++ | ( | int |  | ) |

inline noexcept

Definition at line 447 of file atomic.

## operator++() [4/4]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator++ | ( | int |  | ) | volatile

inline noexcept

Definition at line 456 of file atomic.

## operator+=() [1/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator+= | ( | ptrdiff_t | __d | ) |

inline noexcept

Definition at line 519 of file atomic.

## operator+=() [2/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator+= | ( | ptrdiff_t | __d | ) | volatile

inline noexcept

Definition at line 528 of file atomic.

## operator--() [1/4]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator-- | ( |  | ) |

inline noexcept

Definition at line 501 of file atomic.

## operator--() [2/4]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator-- | ( |  | ) | volatile

inline noexcept

Definition at line 510 of file atomic.

## operator--() [3/4]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator-- | ( | int |  | ) |

inline noexcept

Definition at line 465 of file atomic.

## operator--() [4/4]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator-- | ( | int |  | ) | volatile

inline noexcept

Definition at line 474 of file atomic.

## operator-=() [1/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator-= | ( | ptrdiff_t | __d | ) |

inline noexcept

Definition at line 537 of file atomic.

## operator-=() [2/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator-= | ( | ptrdiff_t | __d | ) | volatile

inline noexcept

Definition at line 546 of file atomic.

## operator=() [1/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator= | ( | __pointer_type | __p | ) |

inline noexcept

Definition at line 439 of file atomic.

## operator=() [2/2]

template<typename _Tp>

__pointer_type std::atomic< _Tp * >::operator= | ( | __pointer_type | __p | ) | volatile

inline noexcept

Definition at line 443 of file atomic.

## store() [1/2]

template<typename _Tp>

void std::atomic< _Tp * >::store | ( | __pointer_type | __p,
|  | memory_order | __m = memory_order_seq_cst )

inline noexcept

Definition at line 567 of file atomic.

## store() [2/2]

template<typename _Tp>

void std::atomic< _Tp * >::store | ( | __pointer_type | __p,
|  | memory_order | __m = memory_order_seq_cst ) volatile

inline noexcept

Definition at line 572 of file atomic.

## Member Data Documentation

## _M_b

template<typename _Tp>

__base_type std::atomic< _Tp * >::_M_b

Definition at line 422 of file atomic.

## is_always_lock_free

template<typename _Tp>

bool std::atomic< _Tp * >::is_always_lock_free

static constexpr

Definition at line 563 of file atomic.

The documentation for this struct was generated from the following file:

- atomic